#ifndef __STM32FWLIB_H
#define __STM32FWLIB_H

#if __cplusplus
extern "C"
{
#endif

#include "stm32f10x_lib.h"

/* Data types used within the AKAE project */

#ifndef NULL
#define NULL ((void*)0)							// provide this to drv_hd44780.h
#endif

typedef double					Flo64;			// Double precision floating point
typedef double					* pFlo64;
typedef float					Flo32;			// Single precision floating point
typedef float					* pFlo32;
typedef signed		long long	Int64S;			// Signed   64 bit quantity
typedef signed		long long	* pInt64S;
typedef unsigned	long long	Int64U;			// Unsigned 64 bit quantity
typedef unsigned	long long	* pInt64U;
typedef signed		int			Int32S;			// Signed   32 bit quantity
typedef signed		int			* pInt32S;
typedef unsigned	int			Int32U;			// Unsigned 32 bit quantity
typedef unsigned	int			* pInt32U;
typedef signed		short		Int16S;			// Signed   16 bit quantity
typedef signed		short		* pInt16S;
typedef unsigned	short		Int16U;			// Unsigned 16 bit quantity
typedef unsigned	short		* pInt16U;
typedef signed		char		Int8S;			// Signed    8 bit quantity
typedef signed		char		* pInt8S;
typedef unsigned	char		Int8U;			// Unsigned  8 bit quantity
typedef unsigned	char		* pInt8U;
typedef unsigned	int			Boolean;
typedef unsigned	int			* pBoolean;

typedef enum {FALSE = 0, TRUE = !FALSE} bool;


/* Support also C++ */
#define BB_BIT(REGISTER, BIT_NUMBER, BASE, BB_BASE) \
	((volatile s32*) ((BB_BASE) + (((u32) &(REGISTER)) - (BASE)) * 32 + (BIT_NUMBER) * 4))

#define PERIPHERAL_BIT(REGISTER, BIT_NUMBER) \
	BB_BIT(REGISTER, BIT_NUMBER, PERIPH_BASE, PERIPH_BB_BASE)

#define SRAM_BIT(REGISTER, BIT_NUMBER) \
	BB_BIT(REGISTER, BIT_NUMBER, SRAM_BASE, SRAM_BB_BASE)

#if __cplusplus
}
#endif

#endif
